<?php

namespace Ebizmarts\MageMonkey\Controller\Index;

/**
 * Responsible for loading page content.
 *
 * This is a basic controller that only loads the corresponding layout file. It may duplicate other such
 * controllers, and thus it is considered tech debt. This code duplication will be resolved in future releases.
 */
class MailChimpDeleteSubscriber extends \Magento\Framework\App\Action\Action {

    protected $_subscriberFactory;
    protected $_storeManager;

    public function __construct(
    \Magento\Framework\App\Action\Context $context, \Magento\Newsletter\Model\SubscriberFactory $subscriberFactory, \Magento\Store\Model\StoreManagerInterface $storeManager
    ) {
        $this->_subscriberFactory = $subscriberFactory;
        $this->_storeManager = $storeManager;
        parent::__construct($context);
    }

    public function execute() {

        $params = $this->getRequest()->getParams();

        if (count($params) > 0) {
            $group_name = $this->_multiDomainHelper->getCurrentGroup($this->_storeManager->getStore()->getWebsite()->getCode());
            $subscriber = $this->_subscriberFactory->create()->loadByEmail($params["data"]["email"], $group_name);

            if ($subscriber && $subscriber->getEmail()) {
                $subscriber->setCheckCode($subscriber->getCode())->unsubscribe();

//                \Magento\Framework\App\ObjectManager::getInstance()
//                        ->get('Psr\Log\LoggerInterface')->debug(print_r($subscriber->getEmail() . " unsubscribed from mailchimp", true));
            } else {
//                \Magento\Framework\App\ObjectManager::getInstance()
//                        ->get('Psr\Log\LoggerInterface')->debug(print_r("No subscriber found for email " . $params["data"]["email"], true));
            }
        }

        return null;
    }

}
